import pathlib
from typing import (Any, Callable, ClassVar, Dict, NoReturn, Optional, Type,
                    TypeVar, overload)

import ansible.module_utils.basic as basic
from _typeshed import Incomplete

T = TypeVar('T')

class AnsibleModule:
    name: ClassVar[str]
    module: basic.AnsibleModule
    result: dict
    module_spec: ClassVar[dict]
    @property
    def params(self) -> Dict[str, Any]: ...
    tmpdir: Incomplete
    def __init__(self) -> None: ...
    def set(self, key: str, value): ...
    @overload
    def diff(self, diff: Dict[str, str]): ...
    @overload
    def diff(
        self,
        before: Optional[str] = ...,
        after: Optional[str] = ...,
        before_header: Optional[str] = ...,
        after_header: Optional[str] = ...,
    ): ...
    def get(self, key: str, default: Optional[T] = ...) -> T: ...
    def changed_get(self): ...
    def changed_set(self, value) -> None: ...
    changed: Incomplete
    def prepare(self) -> None: ...
    def check(self) -> None: ...
    def run(self) -> None: ...
    def __call__(self) -> NoReturn: ...
    @classmethod
    def doc(cls) -> str: ...

class SystemdUnitModule(AnsibleModule):
    unitfile: pathlib.Path
    post: Optional[Callable[[], None]]
    install: ClassVar[Optional[Callable[[SystemdUnitModule], str]]]
    def unit(self) -> str: ...
    def header(self) -> str: ...
    def map_param(self, **parammap: str): ...
    changed: Incomplete
    def unitfile_gen(self) -> None: ...
    def check(self) -> None: ...
    def run(self) -> None: ...

def installable(_class: Type[SystemdUnitModule]): ...

class SystemdReloadMixin:
    module: basic.AnsibleModule
    unitfile: pathlib.Path
    restartable: bool
    changed: bool
    def post(self) -> None: ...
